program WindowsApp;
{$MODE DELPHI}
uses Windows, SysUtils;


{ WSQ library declarations }
function RegisterWSQ():Integer; cdecl; external 'WSQ_library.dll' name '_RegisterWSQ';
function CreateBMPFromFile (const file_name: PCHAR): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromFile';
function SaveBMPToFile(const bitmap: HBITMAP;  const filename: PCHAR; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveBMPToFile';
function CreateBMPFromWSQByteArray (input_wsq_byte_array: PCHAR; const size_of_input_wsq_byte_array: Integer): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromWSQByteArray';
function SaveWSQByteArrayToImageFile(input_wsq_byte_array: PCHAR; const size_of_input_wsq_byte_array: Integer;  const filename: PCHAR; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveWSQByteArrayToImageFile';
procedure SetShowFilePropertiesDialog(file_properties_dialog: Integer); cdecl; external 'WSQ_library.dll' name '_SetShowFilePropertiesDialog';
procedure ShowFileConverter(); cdecl; external 'WSQ_library.dll' name '_ShowFileConverter';
function WSQ_decode_stream(input_data_stream: PCHAR; const input_stream_length: Integer; output_data_stream: PPCHAR; width: PInteger; height: PInteger; ppi: PInteger; comment_text: PPCHAR):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_decode_stream';
function WSQ_encode_stream(input_data_stream: PCHAR; const width: Integer; const height: Integer; const bitrate:Double;
				   const ppi: Integer; comment_text: PCHAR; output_data_stream: PPCHAR; output_stream_length: PInteger):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_encode_stream';
function ConvertHBITMAPtoGrayScale256 (const bitmap: HBITMAP): HBitmap; cdecl; external 'WSQ_library.dll' name '_ConvertHBITMAPtoGrayScale256';
function SaveHBITMAPtoFileAsGrayScale256BMP(const bitmap: HBITMAP;  const filename: PCHAR):Integer; cdecl; external 'WSQ_library.dll' name '_SaveHBITMAPtoFileAsGrayScale256BMP';


var
rect : RECT;
top, left : Integer;

g_bitmapWnd : HWnd;
g_hwndSaveButton : HWnd;
g_hwndDecodeButton : HWnd;
g_hBitmap : HBitmap;
g_pic : BITMAP;


iFileHandle: Integer;
input_data_stream, output_data_stream: PCHAR;
input_data_stream2, output_data_stream2: PCHAR;
image_width, image_height, ppi: Integer;
bitrate: Double;
comment_text: PCHAR;
comment_text2: PCHAR;
ret, n, input_stream_length: Integer;
output_stream2_length: Integer;


strFilter : String;
ofn : OPENFILENAME;
szFileName : PCHAR;
iFileLength : Integer;


BTN_OPEN : LONGINT;
BTN_SAVE : LONGINT;
BTN_REGISTER : LONGINT;
IMG_BITMAP : LONGINT;
BTN_DECODE : LONGINT;
BTN_ENCODE : LONGINT;





function loadFile();
begin

	strFilter := 'All images' + CHAR(0) + '*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;' +
'*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;' +
'*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp' + CHAR(0) + '' +
'FBI Wavelet Scalar Quantization (*.wsq)' + CHAR(0) + '*.wsq' + CHAR(0) + '' +
'Windows bitmaps (*.bmp)' + CHAR(0) + '*.bmp' + CHAR(0) + '' +
'Macintosh TIFF images (*.tiff)' + CHAR(0) + '*.tiff' + CHAR(0) + '' +
'PC TIFF images (*.tif)' + CHAR(0) + '*.tif' + CHAR(0) + '' +
'JPG images (*.jpg)' + CHAR(0) + '*.jpg' + CHAR(0) + '' +
'JPEG-2000 Part-1 (*.jp2)' + CHAR(0) + '*.jp2' + CHAR(0) + '' +
'JPEG-2000 Code Stream (*.jpc)' + CHAR(0) + '*.jpc' + CHAR(0) + '' +
'JPE images (*.jpe)' + CHAR(0) + '*.jpe' + CHAR(0) + '' +
'JPEG images (*.jpeg)' + CHAR(0) + '*.jpeg' + CHAR(0) + '' +
'Portable network graphic images (*.png)' + CHAR(0) + '*.png' + CHAR(0) + '' +
'Compuserve Graphic Interchange Format(*.gif)' + CHAR(0) + '*gif' + CHAR(0) + '' +
'Paintshop Pro images (*.psp)' + CHAR(0) + '*.psp' + CHAR(0) + '' +
'JFIF images (*.jfif)' + CHAR(0) + '*.jfif' + CHAR(0) + '' +
'Run length encoded Windows bitmaps (*.rle)' + CHAR(0) + '*.rle' + CHAR(0) + '' +
'Device independant Windows bitmaps (*.dib)' + CHAR(0) + '*.dib' + CHAR(0) + '' +
'Truevision images (*.win)' + CHAR(0) + '*.win' + CHAR(0) + '' +
'Truevision images (*.vst)' + CHAR(0) + '*.vst' + CHAR(0) + '' +
'Truevision images (*.vda)' + CHAR(0) + '*.vda' + CHAR(0) + '' +
'Truevision images (*.tga)' + CHAR(0) + '*.tga' + CHAR(0) + '' +
'Truevision images (*.icb)' + CHAR(0) + '*.icb' + CHAR(0) + '' +
'GFI fax images (*.fax)' + CHAR(0) + '*.fax' + CHAR(0) + '' +
'Encapsulated Postscript images (*.eps)' + CHAR(0) + '*.eps' + CHAR(0) + '' +
'ZSoft Paintbrush images (*.pcx)' + CHAR(0) + '*.pcx' + CHAR(0) + '' +
'ZSoft Paintbrush images (*.pcc)' + CHAR(0) + '*.pcc' + CHAR(0) + '' +
'Word 5.x screen capture images (*.scr)' + CHAR(0) + '*.scr' + CHAR(0) + '' +
'Alias/Wavefront images (*.rpf)' + CHAR(0) + '*.rpf' + CHAR(0) + '' +
'Alias/Wavefront images (*.rla)' + CHAR(0) + '*.rla' + CHAR(0) + '' +
'SGI true color images (*.sgi)' + CHAR(0) + '*.sgi' + CHAR(0) + '' +
'SGI true color images with alpha (*.rgba)' + CHAR(0) + '*.rgba' + CHAR(0) + '' +
'SGI true color images (*.rgb)' + CHAR(0) + '*.rgb' + CHAR(0) + '' +
'SGI black/white images (*.bw)' + CHAR(0) + '*.bw' + CHAR(0) + '' +
'Photoshop images (*.psd)' + CHAR(0) + '*.psd' + CHAR(0) + '' +
'Photoshop images (*.pdd)' + CHAR(0) + '*.pdd' + CHAR(0) + '' +
'Portable pixel map images (*.ppm)' + CHAR(0) + '*.ppm' + CHAR(0) + '' +
'Portable gray map images (*.pgm)' + CHAR(0) + '*.pgm' + CHAR(0) + '' +
'Portable bitmap images (*.pbm)' + CHAR(0) + '*.pbm' + CHAR(0) + '' +
'Autodesk images (*.cel)' + CHAR(0) + '*.cel' + CHAR(0) + '' +
'Autodesk images (*.pic)' + CHAR(0) + '*.pic' + CHAR(0) + '' +
'Kodak Photo-CD images (*.pcd)' + CHAR(0) + '*.pcd' + CHAR(0) + '' +
'Dr. Halo images (*.cut)' + CHAR(0) + '*.cut' + CHAR(0) + '' +
'Amiga Bitmap Graphic (8 bits)' + CHAR(0) + '*.iff' + CHAR(0) + '' +
'Windows icons (*.ico)' + CHAR(0) + '*.ico' + CHAR(0) + '' +
'Windows metafiles (*.wmf)' + CHAR(0) + '*.wmf' + CHAR(0) + '' +
'Windows enhanced meta files (*.emf)' + CHAR(0) + '*.emf';


    szFileName[0] := CHAR(0);
    ZeroMemory(@ofn, sizeof(OPENFILENAME));
    ofn.lStructSize := sizeof(OPENFILENAME);
    ofn.hwndOwner := 0;
    ofn.hInstance := 0;
    ofn.lpstrFilter := PCHAR(strFilter);
    ofn.nFilterIndex := 1;
    ofn.nMaxFile := MAX_PATH;
    ofn.nMaxFileTitle := 0;
    ofn.lpstrInitialDir := 0;
    ofn.lpstrDefExt := 0;
    ofn.lpstrFile := szFileName;
    ofn.Flags := OFN_FILEMUSTEXIST or OFN_READONLY;


if (GetOpenFileName(@ofn)) then
begin


// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
       g_hBitmap := CreateBMPFromFile(PCHAR(szFileName));

        if ( g_hBitmap <> HBitmap(NIL)) then
        begin
           SendMessage(g_bitmapWnd, STM_SETIMAGE, IMAGE_BITMAP, LPARAM(g_hBitmap));
           EnableWindow(g_hwndSaveButton, true);
        end
        else
        begin
            MessageBox(0, PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;




end;

end;





function saveFile();
begin


	strFilter := 'WSQ Files (*.wsq)' + CHAR(0) + '*.wsq' + CHAR(0) + '' +  // 1
'Windows BMP (*.bmp)' + CHAR(0) + '*.bmp' + CHAR(0) + '' + // 2
'TIFF Files (*.tif)' + CHAR(0) + '*.tif' + CHAR(0) + '' + // 3
'PNG Files (*.png)' + CHAR(0) + '*.png' + CHAR(0) + '' + // 4
'JPEG Files (*.jpg)' + CHAR(0) + '*.jpg' + CHAR(0) + '' + // 5
'Targa Files (*.tga)' + CHAR(0) + '*.tga' + CHAR(0) + '' + // 6
'SGI Files (*.rgb)' + CHAR(0) + '*.rgb' + CHAR(0) + '' + // 7
'JPEG-2000 Part-1 (*.jp2)' + CHAR(0) + '*.jp2' + CHAR(0) + '' + // 8
'JPEG-2000 Code Stream (*.jpc)' + CHAR(0) + '*.jpc' + CHAR(0) + '' + // 9
'PBM - Portable Bitmap Format (*.pbm)' + CHAR(0) + '*.pbm' + CHAR(0) + '' + // 10
'PGM - Portable Graymap Format (*.pgm)' + CHAR(0) + '*.pgm' + CHAR(0) + '' + // 11
'PPM - Portable Pixmap Format (*.ppm)' + CHAR(0) + '*.ppm'; // 12


    szFileName[0] := CHAR(0); 
    ZeroMemory(@ofn, sizeof(OPENFILENAME));
    ofn.lStructSize := sizeof(OPENFILENAME);
    ofn.hwndOwner := 0;
    ofn.hInstance := 0;
    ofn.lpstrFilter := PCHAR(strFilter);
    ofn.nFilterIndex := 1;
    ofn.nMaxFile := MAX_PATH;
    ofn.nMaxFileTitle := 0;
    ofn.lpstrInitialDir := 0;
    ofn.lpstrDefExt := 0;
    ofn.lpstrFile := szFileName;

if (GetSaveFileName(@ofn)) then
begin

    
    g_hBitmap := HBITMAP(SendMessage(g_bitmapWnd, STM_GETIMAGE, IMAGE_BITMAP, LPARAM(0)));
    if ( g_hBitmap = HBitmap(NIL)) then
    begin
       MessageBox(0, 'Unable to get bitmap from view control', 'Error', 0);
       Exit;
    end;

    SaveBMPToFile(g_hBitmap, szFileName, ofn.nFilterIndex);

end;
    
end;





function decodeStream();
begin


	strFilter := 'WSQ Files (*.wsq)' + CHAR(0) + '*.wsq' + CHAR(0);

    szFileName[0] := CHAR(0);
    ZeroMemory(@ofn, sizeof(OPENFILENAME));
    ofn.lStructSize := sizeof(OPENFILENAME);
    ofn.hwndOwner := 0;
    ofn.hInstance := 0;
    ofn.lpstrFilter := PCHAR(strFilter);
    ofn.nFilterIndex := 1;
    ofn.nMaxFile := MAX_PATH;
    ofn.nMaxFileTitle := 0;
    ofn.lpstrInitialDir := 0;
    ofn.lpstrDefExt := 0;
    ofn.lpstrFile := szFileName;
    ofn.Flags := OFN_FILEMUSTEXIST or OFN_READONLY;


if (GetOpenFileName(@ofn)) then
begin

      iFileHandle := FileOpen(ofn.lpstrFile, fmOpenRead);
      iFileLength := FileSeek(iFileHandle,0,2);
      FileSeek(iFileHandle,0,0);
      input_data_stream := PChar(AllocMem(iFileLength + 1));
      input_stream_length := FileRead(iFileHandle, input_data_stream^, iFileLength);
      FileClose(iFileHandle);

// THE DECODING OF WSQ STREAM INTO DECOMPRESSED STREAM
WSQ_decode_stream(input_data_stream, input_stream_length, @output_data_stream, @image_width, @image_height, @ppi, @comment_text);


//Converts WSQ compressed byte array into HBITMAP for showing on screen
       g_hBitmap := CreateBMPFromWSQByteArray(input_data_stream, input_stream_length);
// Saves WSQ compressed byte array to an image file.
       //SaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, PCHAR('C:\OutputDirectory\output.jpg'), 5);


        if ( g_hBitmap <> HBitmap(NIL)) then
        begin
           SendMessage(g_bitmapWnd, STM_SETIMAGE, IMAGE_BITMAP, LPARAM(g_hBitmap));
           EnableWindow(g_hwndDecodeButton, true);
           MessageBox(0, PCHAR('WSQ file was loaded into memory stream and decompressed into another memory stream.' + #13#10 + 'Now please press button "stream -> WSQ" to compress memory stream and save it to file.' + #13#10 + 'WSQ compressed byte array was converted to HBITMAP for showing on screen.'), PCHAR('WSQ image library'), MB_OK );
        end
        else
        begin
            MessageBox(0, PCHAR('Error: unable to decompress WSQ byte array.'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


end;
end;





function encodeStream();
var
    x, y, row, row2, pixel_number, pixel_number2: Integer;
begin


	strFilter := 'WSQ Files (*.wsq)' + CHAR(0) + '*.wsq' + CHAR(0);

    szFileName[0] := CHAR(0);
    ZeroMemory(@ofn, sizeof(OPENFILENAME));
    ofn.lStructSize := sizeof(OPENFILENAME);
    ofn.hwndOwner := 0;
    ofn.hInstance := 0;
    ofn.lpstrFilter := PCHAR(strFilter);
    ofn.nFilterIndex := 1;
    ofn.nMaxFile := MAX_PATH;
    ofn.nMaxFileTitle := 0;
    ofn.lpstrInitialDir := 0;
    ofn.lpstrDefExt := 0;
    ofn.lpstrFile := szFileName;
    

if (GetSaveFileName(@ofn)) then
begin


    bitrate := 0.75;
    ppi := 500;
//    comment_text2 := PCHAR(nil);
    comment_text2 := 'Cognaxon';
    
    if(input_data_stream2 <> PCHAR(nil)) then
    begin
    FreeMem(input_data_stream2); input_data_stream2 := PCHAR(nil);
    end;

    input_data_stream2 := PChar(AllocMem(image_width*image_height));


	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
    for y := 0 to (image_height - 1) do
    begin
      row := image_width * y;
      row2 := image_width * (image_height - y - 1);

        for x := 0 to (image_width - 1) do
        begin
         pixel_number := row + x;
         pixel_number2 := row2 + (image_width - x - 1);

         input_data_stream2[pixel_number2] := output_data_stream[pixel_number];
        end;
    end;


    

// THE ENCODING OF DECOMPRESSED STREAM INTO WSQ STREAM
WSQ_encode_stream(input_data_stream2, image_width, image_height, bitrate, ppi, PCHAR(comment_text2), @output_data_stream2, @output_stream2_length);


    iFileHandle := FileCreate(PCHAR(String(ofn.lpstrFile) + '.wsq'));
    FileWrite(iFileHandle, output_data_stream2^, output_stream2_length);
    FileClose(iFileHandle);

MessageBox(0, PCHAR('Memory stream was compressed into another memory stream and saved to WSQ file.' + #13#10 + 'Now please press button "Open", select the saved file, open it and have a look at the' + #13#10 + 'results of memory stream processing. The processed image is mirrored/flipped' + #13#10 + '(UP<->DOWN and LEFT<->RIGHT).'), PCHAR('WSQ image library'), MB_OK );



end;
end;




const AppName = 'WindowsApp';
function WindowProc(Window: HWnd; AMessage, WParam, LParam: Longint): Longint; stdcall; export;

begin
  WindowProc := 0;


	case AMessage of
        WM_COMMAND:  begin

		//--------------------------------------------------------------------------
		if (LOWORD(WParam) = BTN_REGISTER) then
        begin
			RegisterWSQ();
		end;
		//--------------------------------------------------------------------------
		if (LOWORD(WParam)= BTN_OPEN) then
        begin
			loadFile();
		end;
		//--------------------------------------------------------------------------
		if (LOWORD(WParam) = BTN_SAVE) then
        begin
			saveFile();
		end;
		//--------------------------------------------------------------------------
		if (LOWORD(WParam) = BTN_DECODE) then
        begin
			decodeStream();
		end;
		//--------------------------------------------------------------------------
		if (LOWORD(WParam) = BTN_ENCODE) then
        begin
			encodeStream();
		end;
                   Exit;


                   end;

//  case AMessage of
    wm_Destroy : begin
                   PostQuitMessage(0);
                   Exit;
                 end;
  end;

  WindowProc := DefWindowProc(Window, AMessage, WParam, LParam);
end;




{ Create the Window Class }
function WinCreate: HWnd;
var
WindowClass: WndClass;
hWindow: HWnd;




begin

  WindowClass.Style := cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc := WndProc(@WindowProc);
  WindowClass.cbClsExtra := 0;
  WindowClass.cbWndExtra := 0;
  WindowClass.hInstance := system.MainInstance;
  WindowClass.hIcon := LoadIcon(0, idi_Application);
  WindowClass.hCursor := LoadCursor(0, idc_Arrow);
  WindowClass.hbrBackground := GetStockObject(WHITE_BRUSH);
  WindowClass.lpszMenuName := nil;
  WindowClass.lpszClassName := AppName;

{ Register the Window Class }
  if not (RegisterClass(WindowClass)<> 0) then begin
     MessageBox(0, 'Register failed', nil, mb_Ok);
     Exit;
  end;

  GetWindowRect(GetDesktopWindow(), rect);

  left := (rect.right-355) div 2; // center Window in screen
  top := (rect.bottom-435) div 2; // center Window in screen


  hWindow := CreateWindow(AppName, 'WSQ Library Demo', ws_OverlappedWindow, left, top, 355, 435, 0, 0, system.MainInstance, nil);

  szFileName := PChar(AllocMem(MAX_PATH));


  BTN_OPEN     := 1;
  BTN_SAVE     := 2;
  BTN_REGISTER := 3;
  IMG_BITMAP   := 4;
  BTN_DECODE   := 5;
  BTN_ENCODE   := 6;

	// Drawing area
	g_bitmapWnd := CreateWindowEx(0, 'Static', 'Static', WS_CHILD or WS_VISIBLE or WS_BORDER or SS_BITMAP, 0,0,330,300, hWindow,HMENU(IMG_BITMAP), WindowClass.hInstance, 0); // SS_BITMAP

  if not (g_bitmapWnd <> 0)then begin
     MessageBox(0, 'Unable to create bitmap area', nil, mb_Ok);
     Exit;
  end;

	// Create buttons

	// HWND OpenBtn =
	CreateWindowEx(0, 'BUTTON', 'Open', WS_CHILD or WS_VISIBLE,  10,355,100,33, hWindow, HMENU(BTN_OPEN),0,0);

	g_hwndSaveButton := CreateWindowEx(0, 'BUTTON', 'Save', WS_CHILD or WS_VISIBLE, 115,355,100,33, hWindow, HMENU(BTN_SAVE),0,0);
	EnableWindow(g_hwndSaveButton, false);

	// HWND RegisterBtn = 
	CreateWindowEx(0, 'BUTTON', 'Register', WS_CHILD or WS_VISIBLE, 220, 317, 100, 33, hWindow, HMENU(BTN_REGISTER),0,0);

	// HWND DecodeBtn = 	
	g_hwndDecodeButton := CreateWindowEx(0, 'BUTTON', 'stream->WSQ', WS_CHILD or WS_VISIBLE, 115,317,100,33, hWindow, HMENU(BTN_ENCODE),0,0);
	EnableWindow(g_hwndDecodeButton, false);
	
	// HWND EncodeBtn = 
    CreateWindowEx(0, 'BUTTON', 'WSQ->stream', WS_CHILD or WS_VISIBLE, 10,317,100,33, hWindow, HMENU(BTN_DECODE),0,0);

	
  comment_text := PCHAR(nil);
  comment_text2 := PCHAR(nil);


  if hWindow <> 0 then begin
     ShowWindow(hWindow, CmdShow);
     UpdateWindow(hWindow);
  end;

  Result := hWindow;
end;




var AMessage: Msg;
    hWindow: HWnd;

begin


  hWindow := WinCreate;
  if longint(hWindow) = 0 then begin
     MessageBox(0, 'WinCreate failed', nil, mb_Ok);
     Exit;
  end;

  while GetMessage(@AMessage, 0, 0, 0) do begin
    TranslateMessage(AMessage);
    DispatchMessage(AMessage);
  end;
  Halt(AMessage.wParam);
end.
